Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Friends | List of all members
SceneObject Class Reference

`#include <SceneObject.h>`

Inheritance diagram for SceneObject:

## Public Member Functions
| SceneObject ()
virtual | ~SceneObject ()
virtual bool | onAdd ()
| Engine. More...
virtual void | onRemove ()
| Called when the object is removed from the sim. More...
virtual void | onDestroyNotify (SceneObject *pSceneObject)
virtual void | preIntegrate (const F32 totalTime, const F32 elapsedTime, DebugStats *pDebugStats)
| Integration. More...
virtual void | integrateObject (const F32 totalTime, const F32 elapsedTime, DebugStats *pDebugStats)
virtual void | postIntegrate (const F32 totalTime, const F32 elapsedTime, DebugStats *pDebugStats)
virtual void | interpolateObject (const F32 timeDelta)
bool | getIsEditorTickAllowed (void) const
void | setBatchIsolated (const bool batchIsolated)
| Render batching. More...
virtual bool | getBatchIsolated (void)
virtual bool | isBatchRendered (void)
virtual bool | validRender (void) const
virtual bool | shouldRender (void) const
virtual bool | canPrepareRender (void) const
| Render Output. More...
virtual void | scenePrepareRender (const SceneRenderState *pSceneRenderState, SceneRenderQueue *pSceneRenderQueue)
virtual void | sceneRender (const SceneRenderState *pSceneRenderState, const SceneRenderRequest *pSceneRenderRequest, BatchRender *pBatchRenderer)
virtual void | sceneRenderFallback (const SceneRenderState *pSceneRenderState, const SceneRenderRequest *pSceneRenderRequest, BatchRender *pBatchRenderer)
virtual void | sceneRenderOverlay (const SceneRenderState *pSceneRenderState)
virtual U32 | packUpdate (NetConnection *conn, U32 mask, BitStream *stream)
| Networking. More...
virtual void | unpackUpdate (NetConnection *conn, BitStream *stream)
Scene *const | getScene (void) const
| Scene. More...
F32 | getSceneTime (void) const
virtual void | setEnabled (const bool enabled)
| Enabled. More...
void | setLifetime (const F32 lifetime)
| Lifetime. More...
F32 | getLifetime (void) const
void | updateLifetime (const F32 elapsedTime)
void | setSceneLayer (const U32 sceneLayer)
| Scene layers. More...
U32 | getSceneLayer (void) const
U32 | getSceneLayerMask (void) const
void | setSceneLayerDepth (const F32 order)
| Scene Layer depth. More...
F32 | getSceneLayerDepth (void) const
bool | setSceneLayerDepthFront (void)
bool | setSceneLayerDepthBack (void)
bool | setSceneLayerDepthForward (void)
bool | setSceneLayerDepthBackward (void)
void | setSceneGroup (const U32 sceneGroup)
| Scene groups. More...
U32 | getSceneGroup (void) const
U32 | getSceneGroupMask (void) const
virtual void | setArea (const Vector2 &corner1, const Vector2 &corner2)
| Area. More...
bool | getAutoSizing (void) const
virtual void | setSize (const Vector2 &size)
void | setSize (const F32 width, const F32 height)
Vector2 | getSize (void) const
Vector2 | getHalfSize (void) const
b2AABB | getAABB (void) const
RectF | getAABBRectangle (void) const
S32 | getWorldProxy (void) const
virtual void | setPosition (const Vector2 &position)
| Position / Angle. More...
Vector2 | getPosition (void) const
Vector2 | getRenderPosition (void) const
F32 | getRenderAngle (void) const
const b2Vec2 * | getRenderOOBB (void) const
const b2Vec2 * | getLocalSizedOOBB (void) const
virtual void | setAngle (const F32 radians)
F32 | getAngle (void) const
virtual void | setFixedAngle (const bool fixed)
bool | getFixedAngle (void) const
b2Transform | getTransform (void) const
b2Transform | getRenderTransform (void) const
Vector2 | getLocalCenter (void) const
Vector2 | getWorldCenter (void) const
Vector2 | getLocalPoint (const Vector2 &worldPoint)
Vector2 | getWorldPoint (const Vector2 &localPoint)
Vector2 | getLocalVector (const Vector2 &worldVector)
Vector2 | getWorldVector (const Vector2 &localVector)
bool | getIsPointInOOBB (const Vector2 &worldPoint)
bool | getIsPointInCollisionShape (const U32 shapeIndex, const Vector2 &worldPoint)
virtual ePhysicsProxyType | getPhysicsProxyType (void) const
| Body. More...
b2Body * | getBody (void) const
void | setBodyType (const b2BodyType type)
b2BodyType | getBodyType (void) const
void | setActive (const bool active)
bool | getActive (void) const
void | setAwake (const bool awake)
bool | getAwake (void) const
void | setBullet (const bool bullet)
bool | getBullet (void) const
void | setSleepingAllowed (const bool allowed)
bool | getSleepingAllowed (void) const
F32 | getMass (void) const
F32 | getInertia (void) const
void | setCollisionAgainst (const SceneObject *pSceneObject, const bool clearMasks)
| Collision control. More...
void | setCollisionGroupMask (const U32 groupMask)
U32 | getCollisionGroupMask (void) const
void | setCollisionLayerMask (const U32 layerMask)
U32 | getCollisionLayerMask (void) const
void | setDefaultDensity (const F32 density, const bool updateShapes=true)
F32 | getDefaultDensity (void) const
void | setDefaultFriction (const F32 friction, const bool updateShapes=true)
F32 | getDefaultFriction (void) const
void | setDefaultRestitution (const F32 restitution, const bool updateShapes=true)
F32 | getDefaultRestitution (void) const
void | setCollisionSuppress (const bool status)
bool | getCollisionSuppress (void) const
void | setCollisionOneWay (const bool status)
bool | getCollisionOneWay (void) const
const Scene::typeContactVector * | getCurrentContacts (void) const
U32 | getCurrentContactCount (void) const
virtual void | setGatherContacts (const bool gatherContacts)
bool | getGatherContacts (void) const
virtual void | onBeginCollision (const TickContact &tickContact)
virtual void | onEndCollision (const TickContact &tickContact)
void | setLinearVelocity (const Vector2 &velocity)
| Velocities. More...
Vector2 | getLinearVelocity (void) const
Vector2 | getLinearVelocityFromWorldPoint (const Vector2 &worldPoint)
Vector2 | getLinearVelocityFromLocalPoint (const Vector2 &localPoint)
void | setAngularVelocity (const F32 velocity)
F32 | getAngularVelocity (void) const
void | setLinearDamping (const F32 damping)
F32 | getLinearDamping (void) const
void | setAngularDamping (const F32 damping)
F32 | getAngularDamping (void) const
bool | moveTo (const Vector2 &targetWorldPoint, const F32 speed, const bool autoStop=true, const bool snapToTarget=true, const F32 margin=0.1f)
| Move/Rotate to. More...
bool | rotateTo (const F32 targetAngle, const F32 speed, const bool autoStop=true, const bool warpToTarget=true)
void | cancelMoveTo (const bool autoStop=true)
void | cancelRotateTo (const bool autoStop=true)
bool | isMoveToComplete (void) const
bool | isRotateToComplete (void) const
void | updateTargetPosition (void)
bool | fadeTo (const ColorF &targetColor, const F32 deltaRed, const F32 deltaGreen, const F32 deltaBlue, const F32 deltaAlpha)
void | cancelFadeTo (void)
bool | isFadeToComplete (void) const
void | updateBlendColor (const F32 elapsedTime)
bool | growTo (const Vector2 &targetSize, const Vector2 &deltaSize)
void | cancelGrowTo (void)
bool | isGrowToComplete (void) const
void | updateSize (const F32 elapsedTime)
void | applyForce (const Vector2 &worldForce, const bool wake=true)
| Force and impulse. More...
void | applyForce (const Vector2 &worldForce, const Vector2 &worldPoint, const bool wake=true)
void | applyTorque (const F32 torque, const bool wake=true)
void | applyLinearImpulse (const Vector2 &worldImpulse, const bool wake=true)
void | applyLinearImpulse (const Vector2 &worldImpulse, const Vector2 &worldPoint, const bool wake=true)
void | applyAngularImpulse (const F32 impulse, const bool wake=true)
void | setGravityScale (const F32 scale)
| Gravity scaling. More...
F32 | getGravityScale (void) const
void | deleteCollisionShape (const U32 shapeIndex)
| General collision shape access. More...
void | clearCollisionShapes (void)
U32 | getCollisionShapeCount (void) const
b2Shape::Type | getCollisionShapeType (const U32 shapeIndex) const
S32 | getCollisionShapeIndex (const b2Fixture *pFixture) const
void | setCollisionShapeDefinition (const U32 shapeIndex, const b2FixtureDef &fixtureDef)
b2FixtureDef | getCollisionShapeDefinition (const U32 shapeIndex) const
const b2CircleShape * | getCollisionCircleShape (const U32 shapeIndex) const
const b2PolygonShape * | getCollisionPolygonShape (const U32 shapeIndex) const
const b2ChainShape * | getCollisionChainShape (const U32 shapeIndex) const
const b2EdgeShape * | getCollisionEdgeShape (const U32 shapeIndex) const
void | setCollisionShapeDensity (const U32 shapeIndex, const F32 density)
F32 | getCollisionShapeDensity (const U32 shapeIndex) const
void | setCollisionShapeFriction (const U32 shapeIndex, const F32 friction)
F32 | getCollisionShapeFriction (const U32 shapeIndex) const
void | setCollisionShapeRestitution (const U32 shapeIndex, const F32 restitution)
F32 | getCollisionShapeRestitution (const U32 shapeIndex) const
void | setCollisionShapeIsSensor (const U32 shapeIndex, const bool isSensor)
bool | getCollisionShapeIsSensor (const U32 shapeIndex) const
S32 | createCircleCollisionShape (const F32 radius)
| Circle collision shape creation. More...
S32 | createCircleCollisionShape (const F32 radius, const b2Vec2 &localPosition)
F32 | getCircleCollisionShapeRadius (const U32 shapeIndex) const
| Circle collision shape access. More...
Vector2 | getCircleCollisionShapeLocalPosition (const U32 shapeIndex) const
S32 | createPolygonCollisionShape (const U32 pointCount, const b2Vec2 *localPoints)
| Polygon collision shape creation. More...
S32 | createPolygonBoxCollisionShape (const F32 width, const F32 height)
S32 | createPolygonBoxCollisionShape (const F32 width, const F32 height, const b2Vec2 &localCentroid)
S32 | createPolygonBoxCollisionShape (const F32 width, const F32 height, const b2Vec2 &localCentroid, const F32 rotation)
U32 | getPolygonCollisionShapePointCount (const U32 shapeIndex) const
| Polygon collision shape access. More...
Vector2 | getPolygonCollisionShapeLocalPoint (const U32 shapeIndex, const U32 pointIndex) const
S32 | createChainCollisionShape (const U32 pointCount, const b2Vec2 *localPoints)
| Chain collision shape creation. More...
S32 | createChainCollisionShape (const U32 pointCount, const b2Vec2 *localPoints, const bool hasAdjacentLocalPositionStart, const bool hasAdjacentLocalPositionEnd, const b2Vec2 &adjacentLocalPositionStart, const b2Vec2 &adjacentLocalPositionEnd)
U32 | getChainCollisionShapePointCount (const U32 shapeIndex) const
| Chain collision shape access. More...
Vector2 | getChainCollisionShapeLocalPoint (const U32 shapeIndex, const U32 pointIndex) const
bool | getChainCollisionShapeHasAdjacentStart (const U32 shapeIndex) const
bool | getChainCollisionShapeHasAdjacentEnd (const U32 shapeIndex) const
Vector2 | getChainCollisionShapeAdjacentStart (const U32 shapeIndex) const
Vector2 | getChainCollisionShapeAdjacentEnd (const U32 shapeIndex) const
S32 | createEdgeCollisionShape (const b2Vec2 &localPositionStart, const b2Vec2 &localPositionEnd)
| Edge collision shape creation. More...
S32 | createEdgeCollisionShape (const b2Vec2 &localPositionStart, const b2Vec2 &localPositionEnd, const bool hasAdjacentLocalPositionStart, const bool hasAdjacentLocalPositionEnd, const b2Vec2 &adjacentLocalPositionStart, const b2Vec2 &adjacentLocalPositionEnd)
Vector2 | getEdgeCollisionShapeLocalPositionStart (const U32 shapeIndex) const
| Edge collision shape access. More...
Vector2 | getEdgeCollisionShapeLocalPositionEnd (const U32 shapeIndex) const
bool | getEdgeCollisionShapeHasAdjacentStart (const U32 shapeIndex) const
bool | getEdgeCollisionShapeHasAdjacentEnd (const U32 shapeIndex) const
Vector2 | getEdgeCollisionShapeAdjacentStart (const U32 shapeIndex) const
Vector2 | getEdgeCollisionShapeAdjacentEnd (const U32 shapeIndex) const
void | setVisible (const bool status)
| Render visibility. More...
bool | getVisible (void) const
void | setBlendMode (const bool blendMode)
| Render blending. More...
bool | getBlendMode (void) const
void | setSrcBlendFactor (const S32 blendFactor)
S32 | getSrcBlendFactor (void) const
void | setDstBlendFactor (const S32 blendFactor)
S32 | getDstBlendFactor (void) const
void | setBlendColor (const ColorF &blendColor)
const ColorF & | getBlendColor (void) const
void | setBlendAlpha (const F32 alpha)
F32 | getBlendAlpha (void) const
void | setAlphaTest (const F32 alpha)
F32 | getAlphaTest (void) const
void | setBlendOptions (void)
void | setSortPoint (const Vector2 &pt)
| Render sorting. More...
const Vector2 & | getSortPoint (void) const
void | setRenderGroup (const char *pRenderGroup)
StringTableEntry | getRenderGroup (void) const
void | setUseInputEvents (bool mouseStatus)
| Input events. More...
bool | getUseInputEvents (void) const
virtual void | onInputEvent (StringTableEntry name, const GuiEvent &event, const Vector2 &worldMousePoint)
void | setUpdateCallback (bool status)
bool | getUpdateCallback (void) const
void | setCollisionCallback (const bool status)
bool | getCollisionCallback (void) const
void | setSleepingCallback (bool status)
bool | getSleepingCallback (void) const
void | setDebugOn (const U32 debugMask)
| Debug mode. More...
void | setDebugOff (const U32 debugMask)
U32 | getDebugMask (void) const
void | addCameraMountReference (SceneWindow *pAttachedCamera)
| Camera mounting. More...
void | removeCameraMountReference (void)
void | dismountCamera (void)
void | attachGui (GuiControl *pGuiControl, SceneWindow *pSceneWindow, const bool sizeControl)
void | detachGui (void)
void | updateAttachedGui (void)
void | setPickingAllowed (const bool pickingAllowed)
bool | getPickingAllowed (void) const
virtual void | copyFrom (SceneObject *pSceneObject, const bool copyDynamicFields)
| Cloning. More...
virtual void | copyTo (SimObject *object)
S32 | copyCollisionShapes (SceneObject *pSceneObject, const bool clearTargetShapes=true, const S32 shapeIndex=-1)
void | setSafeDelete (const bool status)
| Safe deletion. More...
bool | getSafeDelete (void) const
bool | isBeingDeleted (void) const
virtual void | safeDelete (void)
void | addDestroyNotification (SceneObject *pSceneObject)
| Destroy notifications. More...
void | removeDestroyNotification (SceneObject *pSceneObject)
void | processDestroyNotifications (void)
void | notifyComponentsAddToScene (void)
| Component notifications. More...
void | notifyComponentsRemoveFromScene (void)
void | notifyComponentsUpdate (void)
const char * | scriptThis (void) const
| Miscellaneous. More...
bool | getIsAlwaysInScope (void) const
void | setWorldQueryKey (const U32 key)
U32 | getWorldQueryKey (void) const
U32 | getSerialId (void) const
virtual bool | writeField (StringTableEntry fieldname, const char *value)
| DECLARE_CONOBJECT (SceneObject)
| Declare Console Object. More...
Public Member Functions inherited from BehaviorComponent
| BehaviorComponent ()
virtual | ~BehaviorComponent ()
virtual void | onDeleteNotify (SimObject *object)
BehaviorInstance * | getBehaviorByInstanceId (const U32 behaviorId)
| Behavior interface. More...
virtual bool | addBehavior (BehaviorInstance *bi)
virtual bool | removeBehavior (BehaviorInstance *bi, bool deleteBehavior=true)
virtual void | clearBehaviors ()
virtual U32 | getBehaviorCount () const
virtual const SimSet & | getBehaviors () const
virtual BehaviorInstance * | getBehavior (StringTableEntry behaviorTemplateName)
virtual BehaviorInstance * | getBehavior (const U32 index)
virtual bool | reOrder (BehaviorInstance *obj, U32 desiredIndex)
bool | connect (BehaviorInstance *pOutputBehavior, BehaviorInstance *pInputBehavior, StringTableEntry pOutputName, StringTableEntry pInputName)
| Behavior connectivity. More...
bool | disconnect (BehaviorInstance *pOutputBehavior, BehaviorInstance *pInputBehavior, StringTableEntry pOutputName, StringTableEntry pInputName)
bool | raise (BehaviorInstance *pOutputBehavior, StringTableEntry pOutputName)
U32 | getBehaviorConnectionCount (BehaviorInstance *pOutputBehavior, StringTableEntry pOutputName)
const BehaviorPortConnection * | getBehaviorConnection (BehaviorInstance *pOutputBehavior, StringTableEntry pOutputName, const U32 connectionIndex)
const typePortConnectionVector * | getBehaviorConnections (BehaviorInstance *pOutputBehavior, StringTableEntry pOutputName)
virtual bool | handlesConsoleMethod (const char *fname, S32 *routingId)
| DynamicConsoleMethodComponent Overrides. More...
virtual const char * | callOnBehaviors (U32 argc, const char *argv[])
virtual void | write (Stream &stream, U32 tabStop, U32 flags=0)
| SimComponent overrides. More...
| DECLARE_CONOBJECT (BehaviorComponent)
Public Member Functions inherited from DynamicConsoleMethodComponent
const char * | callMethod (S32 argc, const char *methodName,...)
| Call Method format string. More...
virtual const char * | callMethodArgList (U32 argc, const char *argv[], bool callThis=true)
| Call Method. More...
| DECLARE_CONOBJECT (DynamicConsoleMethodComponent)
Public Member Functions inherited from SimComponent
| DECLARE_CONOBJECT (SimComponent)
| SimComponent ()
virtual | ~SimComponent ()
virtual bool | processArguments (S32 argc, const char **argv)
| Process constructor options. (ie, new SimObject(1,2,3)) More...
bool | hasComponents () const
| Will return true if this object contains components. More...
const SimComponent * | getOwner () const
| The component which owns this object. More...
virtual StringTableEntry | getComponentName ()
virtual bool | addComponent (SimComponent *component)
| Add Component to this one. More...
virtual bool | removeComponent (SimComponent *component)
| Remove Component from this one. More...
virtual bool | clearComponents ()
| Clear Child components of this one. More...
virtual bool | onComponentAdd (SimComponent *target)
virtual void | onComponentRemove (SimComponent *target)
U32 | getComponentCount ()
SimComponent * | getComponent (const U32 index)
bool | isEnabled () const
virtual void | onUpdate (void)
virtual void | onAddToScene (void)
virtual void | onRemoveFromScene (void)
bool | callMethodOnComponents (U32 argc, const char *argv[], const char **result)
Public Member Functions inherited from SimObject
StringTableEntry | getClassNamespace () const
StringTableEntry | getSuperClassNamespace () const
void | setClassNamespace (const char *classNamespace)
void | setSuperClassNamespace (const char *superClassNamespace)
void | pushScriptCallbackGuard (void)
void | popScriptCallbackGuard (void)
S32 | getScriptCallbackGuard (void)
virtual SimObject * | findObject (const char *name)
Namespace * | getNamespace ()
| Return the object's namespace. More...
const char * | tabComplete (const char *prevText, S32 baseLen, bool)
virtual void | dump ()
virtual void | dumpClassHierarchy ()
SimObject * | clone (const bool copyDynamicFields)
template<typename T >
bool | isType (void)
| DECLARE_CONOBJECT (SimObject)
Notify * | removeNotify (void *ptr, Notify::Type)
| Remove a notification from the list. More...
void | deleteNotify (SimObject *obj)
| Notify an object when we are deleted. More...
void | clearNotify (SimObject *obj)
| Notify an object when we are cleared. More...
void | clearAllNotifications ()
| Remove all notifications for this object. More...
void | processDeleteNotifies ()
| Send out deletion notifications. More...
void | registerReference (SimObject **obj)
void | unregisterReference (SimObject **obj)
const char * | getDataField (StringTableEntry slotName, const char *array)
void | setDataField (StringTableEntry slotName, const char *array, const char *value)
const char * | getPrefixedDataField (StringTableEntry fieldName, const char *array)
void | setPrefixedDataField (StringTableEntry fieldName, const char *array, const char *value)
const char * | getPrefixedDynamicDataField (StringTableEntry fieldName, const char *array, const S32 fieldType=-1)
void | setPrefixedDynamicDataField (StringTableEntry fieldName, const char *array, const char *value, const S32 fieldType=-1)
StringTableEntry | getDataFieldPrefix (StringTableEntry fieldName)
U32 | getDataFieldType (StringTableEntry slotName, const char *array)
SimFieldDictionary * | getFieldDictionary ()
void | clearDynamicFields (void)
| Clear all dynamic fields. More...
void | setCanSaveDynamicFields (bool bCanSave)
| Set whether fields created at runtime should be saved. Default is true. More...
bool | getCanSaveDynamicFields (void) const
| Get whether fields created at runtime should be saved. Default is true. More...
void | setInternalName (const char *newname)
StringTableEntry | getInternalName ()
| Get the internal of of this control. More...
virtual bool | save (const char *pcFilePath, bool bOnlySelected=false)
| Save object as a TorqueScript File. More...
virtual bool | isMethod (const char *methodName)
| Check if a method exists in the objects current namespace. More...
SimObjectId | getId (void) const
StringTableEntry | getIdString (void) const
U32 | getType () const
const StringTableEntry | getName (void) const
void | setId (SimObjectId id)
void | assignName (const char *name)
SimGroup * | getGroup () const
bool | isChildOfGroup (SimGroup *pGroup)
bool | isProperlyAdded () const
bool | isDeleted () const
bool | isRemoved () const
bool | isLocked ()
void | setLocked (bool b)
bool | isHidden ()
void | setHidden (bool b)
void | setProgenitorFile (const char *pFile)
StringTableEntry | getProgenitorFile (void) const
void | setPeriodicTimerID (const S32 timerID)
S32 | getPeriodicTimerID (void) const
bool | isPeriodicTimerActive (void) const
bool | isSelected () const
bool | isExpanded () const
void | setSelected (bool sel)
void | setExpanded (bool exp)
void | setModDynamicFields (bool dyn)
void | setModStaticFields (bool sta)
| SimObject ()
virtual | ~SimObject ()
virtual void | onGroupAdd ()
| Called when the object is added to a SimGroup. More...
virtual void | onGroupRemove ()
| Called when the object is removed from a SimGroup. More...
virtual void | onNameChange (const char *name)
| Called when the object's name is changed. More...
virtual void | onStaticModified (const char *slotName, const char *newValue=NULL)
virtual void | inspectPreApply ()
virtual void | inspectPostApply ()
virtual void | onEditorEnable ()
| Called when the editor is activated. More...
virtual void | onEditorDisable ()
| Called when the editor is deactivated. More...
bool | registerObject ()
bool | registerObject (U32 id)
bool | registerObject (const char *name)
bool | registerObject (const char *name, U32 id)
void | unregisterObject ()
void | deleteObject ()
bool | addToSet (SimObjectId)
bool | addToSet (const char *)
bool | removeFromSet (SimObjectId)
bool | removeFromSet (const char *)
virtual void | writeFields (Stream &stream, U32 tabStop)
virtual bool | writeObject (Stream *stream)
virtual bool | readObject (Stream *stream)
virtual void | buildFilterList ()
void | addFieldFilter (const char *fieldName)
void | removeFieldFilter (const char *fieldName)
void | clearFieldFilters ()
bool | isFiltered (const char *fieldName)
void | assignFieldsFrom (SimObject *obj)
void | assignDynamicFieldsFrom (SimObject *obj)
Public Member Functions inherited from ConsoleObject
const AbstractClassRep::Field * | findField (StringTableEntry fieldName) const
| Get a reference to a field by name. More...
virtual AbstractClassRep * | getClassRep () const
| Gets the ClassRep. More...
bool | setField (const char *fieldName, const char *value)
| Set the value of a field. More...
virtual | ~ConsoleObject ()
const AbstractClassRep::FieldList & | getFieldList () const
| Get a list of all the fields. This information cannot be modified. More...
AbstractClassRep::FieldList & | getModifiableFieldList ()
bool & | getDynamicGroupExpand ()
S32 | getClassId (U32 netClassGroup) const
const char * | getClassName () const
Public Member Functions inherited from SceneRenderObject
| SceneRenderObject ()
virtual | ~SceneRenderObject ()
Public Member Functions inherited from PhysicsProxy
| PhysicsProxy ()
virtual | ~PhysicsProxy ()

## Static Public Member Functions
static void | initPersistFields ()
static void | resetBlendOptions (void)
static U32 | getGlobalSceneObjectCount (void)
static b2BodyType | getBodyTypeEnum (const char *label)
static const char * | getBodyTypeDescription (const b2BodyType bodyType)
static b2Shape::Type | getCollisionShapeTypeEnum (const char *label)
static const char * | getCollisionShapeTypeDescription (const b2Shape::Type collisionShapeType)
static S32 | getSrcBlendFactorEnum (const char *label)
static S32 | getDstBlendFactorEnum (const char *label)
static const char * | getSrcBlendFactorDescription (const GLenum factor)
static const char * | getDstBlendFactorDescription (const GLenum factor)
Static Public Member Functions inherited from SimComponent
static void | initPersistFields ()
static bool | setEnabled (void *obj, const char *data)
static bool | writeEnabled (void *obj, StringTableEntry pFieldName)
Static Public Member Functions inherited from SimObject
static void | initPersistFields ()
Static Public Member Functions inherited from ConsoleObject
static const char * | lookupClassName (const U32 in_classTag)
| Get the classname from a class tag. More...
static void | initPersistFields ()
static void | consoleInit ()
static ConsoleObject * | create (const char *in_pClassName)
static ConsoleObject * | create (const U32 groupId, const U32 typeId, const U32 in_classId)
static AbstractClassRep * | getStaticClassRep ()
| Get the abstract class information for this class. More...
static AbstractClassRep * | getParentStaticClassRep ()
| Get the abstract class information for this class's superclass. More...

## Protected Member Functions
virtual void | OnRegisterScene (Scene *pScene)
| Scene (un)registering. More...
virtual void | OnUnregisterScene (Scene *pScene)
void | resetTickSpatials (const bool resize=false)
| Ticking. More...
bool | getSpatialDirty (void) const
void | initializeContactGathering (void)
| Contact processing. More...
virtual void | onTamlCustomWrite (TamlCustomNodes &customNodes)
| Taml callbacks. More...
virtual void | onTamlCustomRead (const TamlCustomNodes &customNodes)
| Called during the reading of the object to allow custom properties to be read. More...
F32 | processEffect (const F32 current, const F32 target, const F32 rate)
S32 | copyCircleCollisionShapeTo (SceneObject *pSceneObject, const b2FixtureDef &fixtureDef) const
S32 | copyPolygonCollisionShapeTo (SceneObject *pSceneObject, const b2FixtureDef &fixtureDef) const
S32 | copyChainCollisionShapeTo (SceneObject *pSceneObject, const b2FixtureDef &fixtureDef) const
S32 | copyEdgeCollisionShapeTo (SceneObject *pSceneObject, const b2FixtureDef &fixtureDef) const
Protected Member Functions inherited from BehaviorComponent
virtual const char * | _callMethod (U32 argc, const char *argv[], bool callThis=true)
Protected Member Functions inherited from SimComponent
SimComponent * | _getOwner ()
VectorPtr< SimComponent * > & | lockComponentList ()
void | unlockComponentList ()
virtual bool | onComponentRegister (SimComponent *owner)
virtual void | onComponentUnRegister ()
Protected Member Functions inherited from SimObject
virtual void | onTamlPreWrite (void)
| Taml callbacks. More...
virtual void | onTamlPostWrite (void)
| Called after Taml has finished writing the object. More...
virtual void | onTamlPreRead (void)
| Called prior to Taml reading the object. More...
virtual void | onTamlPostRead (const TamlCustomNodes &customNodes)
virtual void | onTamlAddParent (SimObject *pParentObject)
| Called after Taml has finished reading the object and has added the object to any parent. More...
void | linkNamespaces ()
void | unlinkNamespaces ()
Protected Member Functions inherited from ConsoleObject
| ConsoleObject ()
| ConsoleObject (const ConsoleObject &)

## Static Protected Member Functions
static S32 QSORT_CALLBACK | sceneObjectLayerDepthSort (const void *a, const void *b)
static bool | setLifetime (void *obj, const char *data)
| Lifetime. More...
static bool | writeLifetime (void *obj, StringTableEntry pFieldName)
static bool | setSceneLayer (void *obj, const char *data)
| Scene layers. More...
static bool | writeSceneLayer (void *obj, StringTableEntry pFieldName)
static bool | setSceneLayerDepth (void *obj, const char *data)
static bool | writeSceneLayerDepth (void *obj, StringTableEntry pFieldName)
static bool | setSceneGroup (void *obj, const char *data)
| Scene groups. More...
static bool | writeSceneGroup (void *obj, StringTableEntry pFieldName)
static bool | setSize (void *obj, const char *data)
| Area. More...
static bool | writeSize (void *obj, StringTableEntry pFieldName)
static bool | setPosition (void *obj, const char *data)
| Position / Angle. More...
static const char * | getPosition (void *obj, const char *data)
static bool | writePosition (void *obj, StringTableEntry pFieldName)
static bool | setAngle (void *obj, const char *data)
static const char * | getAngle (void *obj, const char *data)
static bool | writeAngle (void *obj, StringTableEntry pFieldName)
static bool | setFixedAngle (void *obj, const char *data)
static const char * | getFixedAngle (void *obj, const char *data)
static bool | writeFixedAngle (void *obj, StringTableEntry pFieldName)
static bool | setBodyType (void *obj, const char *data)
| Body. More...
static const char * | getBodyType (void *obj, const char *data)
static bool | writeBodyType (void *obj, StringTableEntry pFieldName)
static bool | setActive (void *obj, const char *data)
static const char * | getActive (void *obj, const char *data)
static bool | writeActive (void *obj, StringTableEntry pFieldName)
static bool | setAwake (void *obj, const char *data)
static const char * | getAwake (void *obj, const char *data)
static bool | writeAwake (void *obj, StringTableEntry pFieldName)
static bool | setBullet (void *obj, const char *data)
static const char * | getBullet (void *obj, const char *data)
static bool | writeBullet (void *obj, StringTableEntry pFieldName)
static bool | setSleepingAllowed (void *obj, const char *data)
static const char * | getSleepingAllowed (void *obj, const char *data)
static bool | writeSleepingAllowed (void *obj, StringTableEntry pFieldName)
static bool | setDefaultDensity (void *obj, const char *data)
| Collision control. More...
static bool | writeDefaultDensity (void *obj, StringTableEntry pFieldName)
static bool | setDefaultFriction (void *obj, const char *data)
static bool | writeDefaultFriction (void *obj, StringTableEntry pFieldName)
static bool | setDefaultRestitution (void *obj, const char *data)
static bool | writeDefaultRestitution (void *obj, StringTableEntry pFieldName)
static bool | setCollisionGroups (void *obj, const char *data)
static const char * | getCollisionGroups (void *obj, const char *data)
static bool | writeCollisionGroups (void *obj, StringTableEntry pFieldName)
static bool | setCollisionLayers (void *obj, const char *data)
static const char * | getCollisionLayers (void *obj, const char *data)
static bool | writeCollisionLayers (void *obj, StringTableEntry pFieldName)
static bool | writeCollisionSuppress (void *obj, StringTableEntry pFieldName)
static bool | writeCollisionOneWay (void *obj, StringTableEntry pFieldName)
static bool | setGatherContacts (void *obj, const char *data)
static bool | writeGatherContacts (void *obj, StringTableEntry pFieldName)
static bool | setLinearVelocity (void *obj, const char *data)
| Velocities. More...
static const char * | getLinearVelocity (void *obj, const char *data)
static bool | writeLinearVelocity (void *obj, StringTableEntry pFieldName)
static bool | setAngularVelocity (void *obj, const char *data)
static const char * | getAngularVelocity (void *obj, const char *data)
static bool | writeAngularVelocity (void *obj, StringTableEntry pFieldName)
static bool | setLinearDamping (void *obj, const char *data)
static const char * | getLinearDamping (void *obj, const char *data)
static bool | writeLinearDamping (void *obj, StringTableEntry pFieldName)
static bool | setAngularDamping (void *obj, const char *data)
static const char * | getAngularDamping (void *obj, const char *data)
static bool | writeAngularDamping (void *obj, StringTableEntry pFieldName)
static bool | setGravityScale (void *obj, const char *data)
| Gravity scaling. More...
static const char * | getGravityScale (void *obj, const char *data)
static bool | writeGravityScale (void *obj, StringTableEntry pFieldName)
static bool | writeVisible (void *obj, StringTableEntry pFieldName)
| Render visibility. More...
static bool | writeBlendMode (void *obj, StringTableEntry pFieldName)
| Render blending. More...
static bool | writeSrcBlendFactor (void *obj, StringTableEntry pFieldName)
static bool | writeDstBlendFactor (void *obj, StringTableEntry pFieldName)
static bool | writeBlendColor (void *obj, StringTableEntry pFieldName)
static bool | writeAlphaTest (void *obj, StringTableEntry pFieldName)
static bool | writeSortPoint (void *obj, StringTableEntry pFieldName)
| Render sorting. More...
static bool | writeRenderGroup (void *obj, StringTableEntry pFieldName)
static bool | writeUseInputEvents (void *obj, StringTableEntry pFieldName)
| Input events. More...
static bool | writePickingAllowed (void *obj, StringTableEntry pFieldName)
| Picking. More...
static bool | writeUpdateCallback (void *obj, StringTableEntry pFieldName)
| Script callbacks. More...
static bool | writeCollisionCallback (void *obj, StringTableEntry pFieldName)
static bool | writeSleepingCallback (void *obj, StringTableEntry pFieldName)
static bool | setScene (void *obj, const char *data)
| Scene. More...
static bool | writeScene (void *obj, StringTableEntry pFieldName)
Static Protected Member Functions inherited from SimObject
static bool | setClass (void *obj, const char *data)
static bool | setSuperClass (void *obj, const char *data)
static bool | writeCanSaveDynamicFields (void *obj, StringTableEntry pFieldName)
static bool | writeInternalName (void *obj, StringTableEntry pFieldName)
static bool | setParentGroup (void *obj, const char *data)
static bool | writeParentGroup (void *obj, StringTableEntry pFieldName)
static bool | writeSuperclass (void *obj, StringTableEntry pFieldName)
static bool | writeClass (void *obj, StringTableEntry pFieldName)
static SimObject::Notify * | allocNotify ()
| Get a free Notify structure. More...
static void | freeNotify (SimObject::Notify *)
| Mark a Notify structure as free. More...
Static Protected Member Functions inherited from ConsoleObject
static void | addGroup (const char *in_pGroupname, const char *in_pGroupDocs=NULL)
static void | endGroup (const char *in_pGroupname)
static void | addField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, const U32 in_elementCount=1, EnumTable *in_table=NULL, const char *in_pFieldDocs=NULL)
static void | addField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::WriteDataNotify in_writeDataFn, const U32 in_elementCount=1, EnumTable *in_table=NULL, const char *in_pFieldDocs=NULL)
static void | addField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, const char *in_pFieldDocs)
static void | addField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::WriteDataNotify in_writeDataFn, const char *in_pFieldDocs)
static void | addFieldV (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, ConsoleTypeValidator *v, const char *in_pFieldDocs=NULL)
static void | addProtectedField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::SetDataNotify in_setDataFn, AbstractClassRep::GetDataNotify in_getDataFn=&defaultProtectedGetFn, const U32 in_elementCount=1, EnumTable *in_table=NULL, const char *in_pFieldDocs=NULL)
static void | addProtectedField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::SetDataNotify in_setDataFn, AbstractClassRep::GetDataNotify in_getDataFn=&defaultProtectedGetFn, AbstractClassRep::WriteDataNotify in_writeDataFn=&defaultProtectedWriteFn, const U32 in_elementCount=1, EnumTable *in_table=NULL, const char *in_pFieldDocs=NULL)
static void | addProtectedField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::SetDataNotify in_setDataFn, AbstractClassRep::GetDataNotify in_getDataFn=&defaultProtectedGetFn, const char *in_pFieldDocs=NULL)
static void | addProtectedField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::SetDataNotify in_setDataFn, AbstractClassRep::GetDataNotify in_getDataFn=&defaultProtectedGetFn, AbstractClassRep::WriteDataNotify in_writeDataFn=&defaultProtectedWriteFn, const char *in_pFieldDocs=NULL)
static void | addDepricatedField (const char *fieldName)
static bool | removeField (const char *in_pFieldname)

## Protected Attributes
SimObjectPtr< Scene > | mpScene
| Scene. More...
SimObjectPtr< Scene > | mpTargetScene
F32 | mLifetime
| Lifetime. More...
bool | mLifetimeActive
U32 | mSceneLayer
| Scene layers. More...
U32 | mSceneLayerMask
F32 | mSceneLayerDepth
U32 | mSceneGroup
| Scene groups. More...
U32 | mSceneGroupMask
Vector2 | mSize
| Area. More...
bool | mAutoSizing
b2AABB | mPreTickAABB
b2AABB | mCurrentAABB
Vector2 | mLocalSizeOOBB [4]
Vector2 | mRenderOOBB [4]
S32 | mWorldProxyId
bool | mGrowActive
Vector2 | mTargetSize
Vector2 | mDeltaSize
Vector2 | mPreTickPosition
| Position / Angle. More...
F32 | mPreTickAngle
Vector2 | mRenderPosition
F32 | mRenderAngle
bool | mSpatialDirty
Vector2 | mLastCheckedPosition
Vector2 | mTargetPosition
bool | mTargetPositionActive
F32 | mDistanceToTarget
F32 | mTargetPositionMargin
bool | mTargetPositionFound
bool | mSnapToTargetPosition
bool | mStopAtTargetPosition
b2Body * | mpBody
| Body. More...
b2BodyDef | mBodyDefinition
U32 | mWorldQueryKey
U32 | mCollisionLayerMask
| Collision control. More...
U32 | mCollisionGroupMask
bool | mCollisionSuppress
bool | mCollisionOneWay
b2FixtureDef | mDefaultFixture
bool | mGatherContacts
Scene::typeContactVector * | mpCurrentContacts
typeCollisionFixtureDefVector | mCollisionFixtureDefs
| General collision shape access. More...
typeCollisionFixtureVector | mCollisionFixtures
bool | mVisible
| Render visibility. More...
bool | mBlendMode
| Render blending. More...
S32 | mSrcBlendFactor
S32 | mDstBlendFactor
ColorF | mBlendColor
F32 | mAlphaTest
bool | mFadeActive
ColorF | mTargetColor
F32 | mDeltaRed
F32 | mDeltaGreen
F32 | mDeltaBlue
F32 | mDeltaAlpha
Vector2 | mSortPoint
| Render sorting. More...
bool | mUseInputEvents
| Input events. More...
bool | mUpdateCallback
| Script callbacks. More...
bool | mCollisionCallback
bool | mSleepingCallback
bool | mLastAwakeState
U32 | mDebugMask
| Debug mode. More...
SceneWindow * | mpAttachedCamera
| Camera mounting. More...
bool | mAttachedGuiSizeControl
| GUI attachment. More...
GuiControl * | mpAttachedGui
SceneWindow * | mpAttachedGuiSceneWindow
bool | mBeingSafeDeleted
| Safe deletion. More...
bool | mSafeDeleteReady
typeDestroyNotificationVector | mDestroyNotifyList
| Destroy notifications. More...
bool | mBatchIsolated
| Miscellaneous. More...
U32 | mSerialiseKey
bool | mEditorTickAllowed
bool | mPickingAllowed
bool | mAlwaysInScope
U32 | mRotateToEventId
U32 | mSerialId
StringTableEntry | mRenderGroup
Protected Attributes inherited from SimComponent
bool | mEnabled
Protected Attributes inherited from SimObject
SimObjectId | mId
| Id number for this object. More...
StringTableEntry | mIdString
Namespace * | mNameSpace
U32 | mTypeMask
S32 | mScriptCallbackGuard
| Whether the object is executing a script callback. More...
bool | mCanSaveFieldDictionary
| true if dynamic fields (added at runtime) should be saved, defaults to true More...
StringTableEntry | mInternalName
| Stores object Internal Name. More...
StringTableEntry | mClassName
| Stores the class name to link script class namespaces. More...
StringTableEntry | mSuperClassName
| Stores super class name to link script class namespaces. More...

## Friends
class | Scene
class | SceneWindow
class | ContactFilter
class | WorldQuery
class | DebugDraw
class | SceneObjectRotateToEvent

## Additional Inherited Members
Public Types inherited from BehaviorComponent
typedef Vector< BehaviorPortConnection > | typePortConnectionVector
typedef HashMap< StringTableEntry, typePortConnectionVector * > | typeOutputNameConnectionHash
typedef HashMap< SimObjectId, typeOutputNameConnectionHash * > | typeInstanceConnectionHash
Public Types inherited from SimObject
enum | WriteFlags { SelectedOnly = BIT(0) }
Public Types inherited from PhysicsProxy
enum | ePhysicsProxyType { PHYSIC_PROXY_INVALID, PHYSIC_PROXY_CUSTOM, PHYSIC_PROXY_SCENEOBJECT, PHYSIC_PROXY_GROUNDBODY }
Public Attributes inherited from BehaviorComponent
typeInstanceConnectionHash | mBehaviorConnections
Protected Types inherited from SimComponent
typedef VectorPtr< SimComponent * >::iterator | SimComponentIterator
| Returns a const reference to private mComponentList. More...
Static Protected Attributes inherited from SimObject
static SimObject::Notify * | mNotifyFreeList = NULL

## Constructor & Destructor Documentation

SceneObject | ( |  | ) |

~SceneObject | ( |  | ) |
| virtual

## Member Function Documentation

void addCameraMountReference | ( | SceneWindow * | pAttachedCamera | ) |
| inline

Camera mounting.

void addDestroyNotification | ( | SceneObject * | pSceneObject | ) |

Destroy notifications.

void applyAngularImpulse | ( | const F32 | impulse,
|  | const bool | wake = `true`
| ) |  |

void applyForce | ( | const Vector2 & | worldForce,
|  | const bool | wake = `true`
| ) |  |

Force and impulse.

void applyForce | ( | const Vector2 & | worldForce,
|  | const Vector2 & | worldPoint,
|  | const bool | wake = `true`
| ) |  |

void applyLinearImpulse | ( | const Vector2 & | worldImpulse,
|  | const bool | wake = `true`
| ) |  |

void applyLinearImpulse | ( | const Vector2 & | worldImpulse,
|  | const Vector2 & | worldPoint,
|  | const bool | wake = `true`
| ) |  |

void applyTorque | ( | const F32 | torque,
|  | const bool | wake = `true`
| ) |  |

void attachGui | ( | GuiControl * | pGuiControl,
|  | SceneWindow * | pSceneWindow,
|  | const bool | sizeControl
| ) |  |

void cancelFadeTo | ( | void |  | ) |
| inline

void cancelGrowTo | ( | void |  | ) |
| inline

void cancelMoveTo | ( | const bool | autoStop = `true` | ) |

void cancelRotateTo | ( | const bool | autoStop = `true` | ) |

virtual bool canPrepareRender | ( | void |  | ) | const
| inline virtual

Render Output.

Reimplemented in ImageFont, SkeletonObject, CompositeSprite, and WaveComposite.

void clearCollisionShapes | ( | void |  | ) |

S32 copyChainCollisionShapeTo | ( | SceneObject * | pSceneObject,
|  | const b2FixtureDef & | fixtureDef
| ) |  | const
| protected

S32 copyCircleCollisionShapeTo | ( | SceneObject * | pSceneObject,
|  | const b2FixtureDef & | fixtureDef
| ) |  | const
| protected

S32 copyCollisionShapes | ( | SceneObject * | pSceneObject,
|  | const bool | clearTargetShapes = `true`,
|  | const S32 | shapeIndex = `-1`
| ) |  |

S32 copyEdgeCollisionShapeTo | ( | SceneObject * | pSceneObject,
|  | const b2FixtureDef & | fixtureDef
| ) |  | const
| protected

void copyFrom | ( | SceneObject * | pSceneObject,
|  | const bool | copyDynamicFields
| ) |  |
| virtual

Cloning.

S32 copyPolygonCollisionShapeTo | ( | SceneObject * | pSceneObject,
|  | const b2FixtureDef & | fixtureDef
| ) |  | const
| protected

void copyTo | ( | SimObject * | object | ) |
| virtual

Lifetime.

Scene Layers.

Scene groups.

Area.

Position / Angle.

Body.

Collision control.

Velocities.

Gravity scaling.

Collision shapes.

Render visibility.

Render blending.

Render sorting.

Input events.

Misc.

Debug mode.

Reimplemented from BehaviorComponent.

Reimplemented in ParticlePlayer, Scroller, ShapeVector, ImageFont, SkeletonObject, CompositeSprite, Trigger, WaveComposite, SpriteBase, and Sprite.

S32 createChainCollisionShape | ( | const U32 | pointCount,
|  | const b2Vec2 * | localPoints
| ) |  |

Chain collision shape creation.

S32 createChainCollisionShape | ( | const U32 | pointCount,
|  | const b2Vec2 * | localPoints,
|  | const bool | hasAdjacentLocalPositionStart,
|  | const bool | hasAdjacentLocalPositionEnd,
|  | const b2Vec2 & | adjacentLocalPositionStart,
|  | const b2Vec2 & | adjacentLocalPositionEnd
| ) |  |

S32 createCircleCollisionShape | ( | const F32 | radius | ) |

Circle collision shape creation.

S32 createCircleCollisionShape | ( | const F32 | radius,
|  | const b2Vec2 & | localPosition
| ) |  |

S32 createEdgeCollisionShape | ( | const b2Vec2 & | localPositionStart,
|  | const b2Vec2 & | localPositionEnd
| ) |  |

Edge collision shape creation.

S32 createEdgeCollisionShape | ( | const b2Vec2 & | localPositionStart,
|  | const b2Vec2 & | localPositionEnd,
|  | const bool | hasAdjacentLocalPositionStart,
|  | const bool | hasAdjacentLocalPositionEnd,
|  | const b2Vec2 & | adjacentLocalPositionStart,
|  | const b2Vec2 & | adjacentLocalPositionEnd
| ) |  |

S32 createPolygonBoxCollisionShape | ( | const F32 | width,
|  | const F32 | height
| ) |  |

S32 createPolygonBoxCollisionShape | ( | const F32 | width,
|  | const F32 | height,
|  | const b2Vec2 & | localCentroid
| ) |  |

S32 createPolygonBoxCollisionShape | ( | const F32 | width,
|  | const F32 | height,
|  | const b2Vec2 & | localCentroid,
|  | const F32 | rotation
| ) |  |

S32 createPolygonCollisionShape | ( | const U32 | pointCount,
|  | const b2Vec2 * | localPoints
| ) |  |

Polygon collision shape creation.

DECLARE_CONOBJECT | ( | SceneObject |  | ) |

Declare Console Object.

void deleteCollisionShape | ( | const U32 | shapeIndex | ) |

General collision shape access.

void detachGui | ( | void |  | ) |

void dismountCamera | ( | void |  | ) |
| inline

bool fadeTo | ( | const ColorF & | targetColor,
|  | const F32 | deltaRed,
|  | const F32 | deltaGreen,
|  | const F32 | deltaBlue,
|  | const F32 | deltaAlpha
| ) |  |

b2AABB getAABB | ( | void |  | ) | const
| inline

RectF getAABBRectangle | ( | void |  | ) | const
| inline

bool getActive | ( | void |  | ) | const
| inline

static const char* getActive | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

F32 getAlphaTest | ( | void |  | ) | const
| inline

F32 getAngle | ( | void |  | ) | const
| inline

static const char* getAngle | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

F32 getAngularDamping | ( | void |  | ) | const
| inline

static const char* getAngularDamping | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

F32 getAngularVelocity | ( | void |  | ) | const
| inline

static const char* getAngularVelocity | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

bool getAutoSizing | ( | void |  | ) | const
| inline

bool getAwake | ( | void |  | ) | const
| inline

static const char* getAwake | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

virtual bool getBatchIsolated | ( | void |  | ) |
| inline virtual

Implements SceneRenderObject.

F32 getBlendAlpha | ( | void |  | ) | const
| inline

const ColorF& getBlendColor | ( | void |  | ) | const
| inline

bool getBlendMode | ( | void |  | ) | const
| inline

b2Body* getBody | ( | void |  | ) | const
| inline

b2BodyType getBodyType | ( | void |  | ) | const
| inline

static const char* getBodyType | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

const char * getBodyTypeDescription | ( | const b2BodyType | bodyType | ) |
| static

b2BodyType getBodyTypeEnum | ( | const char * | label | ) |
| static

bool getBullet | ( | void |  | ) | const
| inline

static const char* getBullet | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Vector2 getChainCollisionShapeAdjacentEnd | ( | const U32 | shapeIndex | ) | const

Vector2 getChainCollisionShapeAdjacentStart | ( | const U32 | shapeIndex | ) | const

bool getChainCollisionShapeHasAdjacentEnd | ( | const U32 | shapeIndex | ) | const

bool getChainCollisionShapeHasAdjacentStart | ( | const U32 | shapeIndex | ) | const

Vector2 getChainCollisionShapeLocalPoint | ( | const U32 | shapeIndex,
|  | const U32 | pointIndex
| ) |  | const

U32 getChainCollisionShapePointCount | ( | const U32 | shapeIndex | ) | const

Chain collision shape access.

Vector2 getCircleCollisionShapeLocalPosition | ( | const U32 | shapeIndex | ) | const

F32 getCircleCollisionShapeRadius | ( | const U32 | shapeIndex | ) | const

Circle collision shape access.

bool getCollisionCallback | ( | void |  | ) | const
| inline

const b2ChainShape * getCollisionChainShape | ( | const U32 | shapeIndex | ) | const

const b2CircleShape * getCollisionCircleShape | ( | const U32 | shapeIndex | ) | const

const b2EdgeShape * getCollisionEdgeShape | ( | const U32 | shapeIndex | ) | const

U32 getCollisionGroupMask | ( | void |  | ) | const
| inline

static const char* getCollisionGroups | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

U32 getCollisionLayerMask | ( | void |  | ) | const
| inline

static const char* getCollisionLayers | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

bool getCollisionOneWay | ( | void |  | ) | const
| inline

const b2PolygonShape * getCollisionPolygonShape | ( | const U32 | shapeIndex | ) | const

U32 getCollisionShapeCount | ( | void |  | ) | const
| inline

b2FixtureDef getCollisionShapeDefinition | ( | const U32 | shapeIndex | ) | const

F32 getCollisionShapeDensity | ( | const U32 | shapeIndex | ) | const

F32 getCollisionShapeFriction | ( | const U32 | shapeIndex | ) | const

S32 getCollisionShapeIndex | ( | const b2Fixture * | pFixture | ) | const

bool getCollisionShapeIsSensor | ( | const U32 | shapeIndex | ) | const

F32 getCollisionShapeRestitution | ( | const U32 | shapeIndex | ) | const

b2Shape::Type getCollisionShapeType | ( | const U32 | shapeIndex | ) | const

const char * getCollisionShapeTypeDescription | ( | const b2Shape::Type | collisionShapeType | ) |
| static

b2Shape::Type getCollisionShapeTypeEnum | ( | const char * | label | ) |
| static

bool getCollisionSuppress | ( | void |  | ) | const
| inline

U32 getCurrentContactCount | ( | void |  | ) | const
| inline

const Scene::typeContactVector* getCurrentContacts | ( | void |  | ) | const
| inline

U32 getDebugMask | ( | void |  | ) | const
| inline

F32 getDefaultDensity | ( | void |  | ) | const
| inline

F32 getDefaultFriction | ( | void |  | ) | const
| inline

F32 getDefaultRestitution | ( | void |  | ) | const
| inline

S32 getDstBlendFactor | ( | void |  | ) | const
| inline

const char * getDstBlendFactorDescription | ( | const GLenum | factor | ) |
| static

S32 getDstBlendFactorEnum | ( | const char * | label | ) |
| static

Vector2 getEdgeCollisionShapeAdjacentEnd | ( | const U32 | shapeIndex | ) | const

Vector2 getEdgeCollisionShapeAdjacentStart | ( | const U32 | shapeIndex | ) | const

bool getEdgeCollisionShapeHasAdjacentEnd | ( | const U32 | shapeIndex | ) | const

bool getEdgeCollisionShapeHasAdjacentStart | ( | const U32 | shapeIndex | ) | const

Vector2 getEdgeCollisionShapeLocalPositionEnd | ( | const U32 | shapeIndex | ) | const

Vector2 getEdgeCollisionShapeLocalPositionStart | ( | const U32 | shapeIndex | ) | const

Edge collision shape access.

bool getFixedAngle | ( | void |  | ) | const
| inline

static const char* getFixedAngle | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

bool getGatherContacts | ( | void |  | ) | const
| inline

U32 getGlobalSceneObjectCount | ( | void |  | ) |
| static

F32 getGravityScale | ( | void |  | ) | const
| inline

static const char* getGravityScale | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Vector2 getHalfSize | ( | void |  | ) | const
| inline

F32 getInertia | ( | void |  | ) | const
| inline

bool getIsAlwaysInScope | ( | void |  | ) | const
| inline

bool getIsEditorTickAllowed | ( | void |  | ) | const
| inline

bool getIsPointInCollisionShape | ( | const U32 | shapeIndex,
|  | const Vector2 & | worldPoint
| ) |  |

bool getIsPointInOOBB | ( | const Vector2 & | worldPoint | ) |

F32 getLifetime | ( | void |  | ) | const
| inline

F32 getLinearDamping | ( | void |  | ) | const
| inline

static const char* getLinearDamping | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Vector2 getLinearVelocity | ( | void |  | ) | const
| inline

static const char* getLinearVelocity | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Vector2 getLinearVelocityFromLocalPoint | ( | const Vector2 & | localPoint | ) |
| inline

Vector2 getLinearVelocityFromWorldPoint | ( | const Vector2 & | worldPoint | ) |
| inline

Vector2 getLocalCenter | ( | void |  | ) | const
| inline

Vector2 getLocalPoint | ( | const Vector2 & | worldPoint | ) |

const b2Vec2* getLocalSizedOOBB | ( | void |  | ) | const
| inline

Vector2 getLocalVector | ( | const Vector2 & | worldVector | ) |

F32 getMass | ( | void |  | ) | const
| inline

virtual ePhysicsProxyType getPhysicsProxyType | ( | void |  | ) | const
| inline virtual

Body.

Implements PhysicsProxy.

bool getPickingAllowed | ( | void |  | ) | const
| inline

Vector2 getPolygonCollisionShapeLocalPoint | ( | const U32 | shapeIndex,
|  | const U32 | pointIndex
| ) |  | const

U32 getPolygonCollisionShapePointCount | ( | const U32 | shapeIndex | ) | const

Polygon collision shape access.

Vector2 getPosition | ( | void |  | ) | const
| inline

static const char* getPosition | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

F32 getRenderAngle | ( | void |  | ) | const
| inline

StringTableEntry getRenderGroup | ( | void |  | ) | const
| inline

const b2Vec2* getRenderOOBB | ( | void |  | ) | const
| inline

Vector2 getRenderPosition | ( | void |  | ) | const
| inline

b2Transform getRenderTransform | ( | void |  | ) | const
| inline

bool getSafeDelete | ( | void |  | ) | const
| inline

Scene* const getScene | ( | void |  | ) | const
| inline

Scene.

U32 getSceneGroup | ( | void |  | ) | const
| inline

U32 getSceneGroupMask | ( | void |  | ) | const
| inline

U32 getSceneLayer | ( | void |  | ) | const
| inline

F32 getSceneLayerDepth | ( | void |  | ) | const
| inline

U32 getSceneLayerMask | ( | void |  | ) | const
| inline

F32 getSceneTime | ( | void |  | ) | const
| inline

U32 getSerialId | ( | void |  | ) | const
| inline

Vector2 getSize | ( | void |  | ) | const
| inline

bool getSleepingAllowed | ( | void |  | ) | const
| inline

static const char* getSleepingAllowed | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

bool getSleepingCallback | ( | void |  | ) | const
| inline

const Vector2& getSortPoint | ( | void |  | ) | const
| inline

bool getSpatialDirty | ( | void |  | ) | const
| inline protected

S32 getSrcBlendFactor | ( | void |  | ) | const
| inline

const char * getSrcBlendFactorDescription | ( | const GLenum | factor | ) |
| static

S32 getSrcBlendFactorEnum | ( | const char * | label | ) |
| static

b2Transform getTransform | ( | void |  | ) | const
| inline

bool getUpdateCallback | ( | void |  | ) | const
| inline

bool getUseInputEvents | ( | void |  | ) | const
| inline

bool getVisible | ( | void |  | ) | const
| inline

Vector2 getWorldCenter | ( | void |  | ) | const
| inline

Vector2 getWorldPoint | ( | const Vector2 & | localPoint | ) |

S32 getWorldProxy | ( | void |  | ) | const
| inline

U32 getWorldQueryKey | ( | void |  | ) | const
| inline

Vector2 getWorldVector | ( | const Vector2 & | localVector | ) |

bool growTo | ( | const Vector2 & | targetSize,
|  | const Vector2 & | deltaSize
| ) |  |

void initializeContactGathering | ( | void |  | ) |
| protected

Contact processing.

void initPersistFields | ( |  | ) |
| static

Lifetime.

Scene Layers.

Area.

Position / Angle.

Body.

Collision control.

Velocities.

Gravity scaling.

Render visibility.

Render blending.

Render sorting.

Input events.

Scene.

void integrateObject | ( | const F32 | totalTime,
|  | const F32 | elapsedTime,
|  | DebugStats * | pDebugStats
| ) |  |
| virtual

Reimplemented in ParticlePlayer, Scroller, SkeletonObject, CompositeSprite, Trigger, WaveComposite, and SpriteBase.

void interpolateObject | ( | const F32 | timeDelta | ) |
| virtual

Reimplemented in ParticlePlayer, Scroller, SkeletonObject, CompositeSprite, and WaveComposite.

virtual bool isBatchRendered | ( | void |  | ) |
| inline virtual

Implements SceneRenderObject.

Reimplemented in ShapeVector.

bool isBeingDeleted | ( | void |  | ) | const
| inline

bool isFadeToComplete | ( | void |  | ) | const
| inline

bool isGrowToComplete | ( | void |  | ) | const
| inline

bool isMoveToComplete | ( | void |  | ) | const
| inline

bool isRotateToComplete | ( | void |  | ) | const
| inline

bool moveTo | ( | const Vector2 & | targetWorldPoint,
|  | const F32 | speed,
|  | const bool | autoStop = `true`,
|  | const bool | snapToTarget = `true`,
|  | const F32 | margin = `0.1f`
| ) |  |

Move/Rotate to.

void notifyComponentsAddToScene | ( | void |  | ) |

Component notifications.

void notifyComponentsRemoveFromScene | ( | void |  | ) |

void notifyComponentsUpdate | ( | void |  | ) |

bool onAdd | ( | void |  | ) |
| virtual

Engine.

Reimplemented from BehaviorComponent.

Reimplemented in Scroller, ImageFont, ShapeVector, CompositeSprite, and Trigger.

void onBeginCollision | ( | const TickContact & | tickContact | ) |
| virtual

Reimplemented in Trigger.

void onDestroyNotify | ( | SceneObject * | pSceneObject | ) |
| virtual

void onEndCollision | ( | const TickContact & | tickContact | ) |
| virtual

Reimplemented in Trigger.

void onInputEvent | ( | StringTableEntry | name,
|  | const GuiEvent & | event,
|  | const Vector2 & | worldMousePoint
| ) |  |
| virtual

void OnRegisterScene | ( | Scene * | pScene | ) |
| protected virtual

Scene (un)registering.

Reimplemented in ParticlePlayer.

void onRemove | ( |  | ) |
| virtual

Called when the object is removed from the sim.

Reimplemented from BehaviorComponent.

Reimplemented in Scroller, ImageFont, ShapeVector, and CompositeSprite.

void onTamlCustomRead | ( | const TamlCustomNodes & | customNodes | ) |
| protected virtual

Called during the reading of the object to allow custom properties to be read.

Reimplemented from BehaviorComponent.

Reimplemented in CompositeSprite.

void onTamlCustomWrite | ( | TamlCustomNodes & | customNodes | ) |
| protected virtual

Taml callbacks.

Reimplemented from BehaviorComponent.

Reimplemented in CompositeSprite.

void OnUnregisterScene | ( | Scene * | pScene | ) |
| protected virtual

Reimplemented in ParticlePlayer.

U32 packUpdate | ( | NetConnection * | conn,
|  | U32 | mask,
|  | BitStream * | stream
| ) |  |
| virtual

Networking.

void postIntegrate | ( | const F32 | totalTime,
|  | const F32 | elapsedTime,
|  | DebugStats * | pDebugStats
| ) |  |
| virtual

void preIntegrate | ( | const F32 | totalTime,
|  | const F32 | elapsedTime,
|  | DebugStats * | pDebugStats
| ) |  |
| virtual

Integration.

Reimplemented in ParticlePlayer, SkeletonObject, CompositeSprite, Trigger, and WaveComposite.

void processDestroyNotifications | ( | void |  | ) |

F32 processEffect | ( | const F32 | current,
|  | const F32 | target,
|  | const F32 | rate
| ) |  |
| protected

void removeCameraMountReference | ( | void |  | ) |
| inline

void removeDestroyNotification | ( | SceneObject * | pSceneObject | ) |

void resetBlendOptions | ( | void |  | ) |
| static

void resetTickSpatials | ( | const bool | resize = `false` | ) |
| protected

Ticking.

bool rotateTo | ( | const F32 | targetAngle,
|  | const F32 | speed,
|  | const bool | autoStop = `true`,
|  | const bool | warpToTarget = `true`
| ) |  |

void safeDelete | ( | void |  | ) |
| virtual

Reimplemented in ParticlePlayer.

S32 QSORT_CALLBACK sceneObjectLayerDepthSort | ( | const void * | a,
|  | const void * | b
| ) |  |
| static protected

virtual void scenePrepareRender | ( | const SceneRenderState * | pSceneRenderState,
|  | SceneRenderQueue * | pSceneRenderQueue
| ) |  |
| inline virtual

Implements SceneRenderObject.

Reimplemented in ImageFont, SkeletonObject, CompositeSprite, and WaveComposite.

virtual void sceneRender | ( | const SceneRenderState * | pSceneRenderState,
|  | const SceneRenderRequest * | pSceneRenderRequest,
|  | BatchRender * | pBatchRenderer
| ) |  |
| inline virtual

Implements SceneRenderObject.

Reimplemented in ParticlePlayer, Scroller, ImageFont, ShapeVector, SkeletonObject, CompositeSprite, WaveComposite, and Sprite.

void sceneRenderFallback | ( | const SceneRenderState * | pSceneRenderState,
|  | const SceneRenderRequest * | pSceneRenderRequest,
|  | BatchRender * | pBatchRenderer
| ) |  |
| virtual

Implements SceneRenderObject.

void sceneRenderOverlay | ( | const SceneRenderState * | pSceneRenderState | ) |
| virtual

Reimplemented in ParticlePlayer.

const char* scriptThis | ( | void |  | ) | const
| inline

Miscellaneous.

void setActive | ( | const bool | active | ) |
| inline

static bool setActive | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setAlphaTest | ( | const F32 | alpha | ) |
| inline

void setAngle | ( | const F32 | radians | ) |
| virtual

Reimplemented in Scroller.

static bool setAngle | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setAngularDamping | ( | const F32 | damping | ) |
| inline

static bool setAngularDamping | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setAngularVelocity | ( | const F32 | velocity | ) |
| inline

static bool setAngularVelocity | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setArea | ( | const Vector2 & | corner1,
|  | const Vector2 & | corner2
| ) |  |
| virtual

Area.

void setAwake | ( | const bool | awake | ) |
| inline

static bool setAwake | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setBatchIsolated | ( | const bool | batchIsolated | ) |
| inline

Render batching.

void setBlendAlpha | ( | const F32 | alpha | ) |
| inline

void setBlendColor | ( | const ColorF & | blendColor | ) |
| inline

void setBlendMode | ( | const bool | blendMode | ) |
| inline

Render blending.

void setBlendOptions | ( | void |  | ) |

void setBodyType | ( | const b2BodyType | type | ) |

static bool setBodyType | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Body.

void setBullet | ( | const bool | bullet | ) |
| inline

static bool setBullet | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setCollisionAgainst | ( | const SceneObject * | pSceneObject,
|  | const bool | clearMasks
| ) |  |

Collision control.

void setCollisionCallback | ( | const bool | status | ) |
| inline

void setCollisionGroupMask | ( | const U32 | groupMask | ) |
| inline

static bool setCollisionGroups | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setCollisionLayerMask | ( | const U32 | layerMask | ) |
| inline

static bool setCollisionLayers | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setCollisionOneWay | ( | const bool | status | ) |
| inline

void setCollisionShapeDefinition | ( | const U32 | shapeIndex,
|  | const b2FixtureDef & | fixtureDef
| ) |  |

void setCollisionShapeDensity | ( | const U32 | shapeIndex,
|  | const F32 | density
| ) |  |

void setCollisionShapeFriction | ( | const U32 | shapeIndex,
|  | const F32 | friction
| ) |  |

void setCollisionShapeIsSensor | ( | const U32 | shapeIndex,
|  | const bool | isSensor
| ) |  |

void setCollisionShapeRestitution | ( | const U32 | shapeIndex,
|  | const F32 | restitution
| ) |  |

void setCollisionSuppress | ( | const bool | status | ) |
| inline

void setDebugOff | ( | const U32 | debugMask | ) |
| inline

void setDebugOn | ( | const U32 | debugMask | ) |
| inline

Debug mode.

void setDefaultDensity | ( | const F32 | density,
|  | const bool | updateShapes = `true`
| ) |  |

static bool setDefaultDensity | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Collision control.

void setDefaultFriction | ( | const F32 | friction,
|  | const bool | updateShapes = `true`
| ) |  |

static bool setDefaultFriction | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setDefaultRestitution | ( | const F32 | restitution,
|  | const bool | updateShapes = `true`
| ) |  |

static bool setDefaultRestitution | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setDstBlendFactor | ( | const S32 | blendFactor | ) |
| inline

void setEnabled | ( | const bool | enabled | ) |
| virtual

Enabled.

Reimplemented from SimComponent.

virtual void setFixedAngle | ( | const bool | fixed | ) |
| inline virtual

Reimplemented in Scroller.

static bool setFixedAngle | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

virtual void setGatherContacts | ( | const bool | gatherContacts | ) |
| inline virtual

Reimplemented in Trigger.

static bool setGatherContacts | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setGravityScale | ( | const F32 | scale | ) |
| inline

Gravity scaling.

static bool setGravityScale | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Gravity scaling.

void setLifetime | ( | const F32 | lifetime | ) |

Lifetime.

static bool setLifetime | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Lifetime.

void setLinearDamping | ( | const F32 | damping | ) |
| inline

static bool setLinearDamping | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setLinearVelocity | ( | const Vector2 & | velocity | ) |
| inline

Velocities.

static bool setLinearVelocity | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Velocities.

void setPickingAllowed | ( | const bool | pickingAllowed | ) |
| inline

void setPosition | ( | const Vector2 & | position | ) |
| virtual

Position / Angle.

static bool setPosition | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Position / Angle.

void setRenderGroup | ( | const char * | pRenderGroup | ) |
| inline

void setSafeDelete | ( | const bool | status | ) |
| inline

Safe deletion.

static bool setScene | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Scene.

void setSceneGroup | ( | const U32 | sceneGroup | ) |

Scene groups.

static bool setSceneGroup | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Scene groups.

void setSceneLayer | ( | const U32 | sceneLayer | ) |

Scene layers.

static bool setSceneLayer | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Scene layers.

void setSceneLayerDepth | ( | const F32 | order | ) |
| inline

Scene Layer depth.

static bool setSceneLayerDepth | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

bool setSceneLayerDepthBack | ( | void |  | ) |

bool setSceneLayerDepthBackward | ( | void |  | ) |

bool setSceneLayerDepthForward | ( | void |  | ) |

bool setSceneLayerDepthFront | ( | void |  | ) |

void setSize | ( | const Vector2 & | size | ) |
| virtual

Reimplemented in ShapeVector.

void setSize | ( | const F32 | width,
|  | const F32 | height
| ) |  |
| inline

static bool setSize | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

Area.

void setSleepingAllowed | ( | const bool | allowed | ) |
| inline

static bool setSleepingAllowed | ( | void * | obj,
|  | const char * | data
| ) |  |
| inline static protected

void setSleepingCallback | ( | bool | status | ) |
| inline

void setSortPoint | ( | const Vector2 & | pt | ) |
| inline

Render sorting.

void setSrcBlendFactor | ( | const S32 | blendFactor | ) |
| inline

void setUpdateCallback | ( | bool | status | ) |
| inline

void setUseInputEvents | ( | bool | mouseStatus | ) |
| inline

Input events.

void setVisible | ( | const bool | status | ) |
| inline

Render visibility.

void setWorldQueryKey | ( | const U32 | key | ) |
| inline

virtual bool shouldRender | ( | void |  | ) | const
| inline virtual

Implements SceneRenderObject.

Reimplemented in ParticlePlayer, ImageFont, ShapeVector, SkeletonObject, CompositeSprite, Trigger, WaveComposite, and SpriteBase.

void unpackUpdate | ( | NetConnection * | conn,
|  | BitStream * | stream
| ) |  |
| virtual

void updateAttachedGui | ( | void |  | ) |
| inline

void updateBlendColor | ( | const F32 | elapsedTime | ) |

void updateLifetime | ( | const F32 | elapsedTime | ) |

void updateSize | ( | const F32 | elapsedTime | ) |

void updateTargetPosition | ( | void |  | ) |

virtual bool validRender | ( | void |  | ) | const
| inline virtual

Implements SceneRenderObject.

Reimplemented in ParticlePlayer, ImageFont, ShapeVector, SkeletonObject, WaveComposite, and SpriteBase.

static bool writeActive | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeAlphaTest | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeAngle | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeAngularDamping | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeAngularVelocity | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeAwake | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeBlendColor | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeBlendMode | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

Render blending.

static bool writeBodyType | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeBullet | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeCollisionCallback | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeCollisionGroups | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeCollisionLayers | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeCollisionOneWay | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeCollisionSuppress | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeDefaultDensity | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeDefaultFriction | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeDefaultRestitution | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeDstBlendFactor | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

bool writeField | ( | StringTableEntry | fieldname,
|  | const char * | value
| ) |  |
| virtual

Determine whether or not a field should be written.

Parameters

  fieldname | The name of the field being written.
  value | The value of the field.

Reimplemented from SimComponent.

static bool writeFixedAngle | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeGatherContacts | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeGravityScale | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeLifetime | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeLinearDamping | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeLinearVelocity | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writePickingAllowed | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

Picking.

static bool writePosition | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeRenderGroup | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeScene | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeSceneGroup | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeSceneLayer | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeSceneLayerDepth | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeSize | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeSleepingAllowed | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeSleepingCallback | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeSortPoint | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

Render sorting.

static bool writeSrcBlendFactor | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeUpdateCallback | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

Script callbacks.

static bool writeUseInputEvents | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

Input events.

static bool writeVisible | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

Render visibility.

## Friends And Related Function Documentation

friend class ContactFilter
| friend

friend class DebugDraw
| friend

friend class Scene
| friend

friend class SceneObjectRotateToEvent
| friend

friend class SceneWindow
| friend

friend class WorldQuery
| friend

## Member Data Documentation

F32 mAlphaTest
| protected

bool mAlwaysInScope
| protected

bool mAttachedGuiSizeControl
| protected

GUI attachment.

bool mAutoSizing
| protected

bool mBatchIsolated
| protected

Miscellaneous.

bool mBeingSafeDeleted
| protected

Safe deletion.

ColorF mBlendColor
| protected

bool mBlendMode
| protected

Render blending.

b2BodyDef mBodyDefinition
| protected

bool mCollisionCallback
| protected

typeCollisionFixtureDefVector mCollisionFixtureDefs
| protected

General collision shape access.

typeCollisionFixtureVector mCollisionFixtures
| protected

U32 mCollisionGroupMask
| protected

U32 mCollisionLayerMask
| protected

Collision control.

bool mCollisionOneWay
| protected

bool mCollisionSuppress
| protected

b2AABB mCurrentAABB
| protected

U32 mDebugMask
| protected

Debug mode.

b2FixtureDef mDefaultFixture
| protected

F32 mDeltaAlpha
| protected

F32 mDeltaBlue
| protected

F32 mDeltaGreen
| protected

F32 mDeltaRed
| protected

Vector2 mDeltaSize
| protected

typeDestroyNotificationVector mDestroyNotifyList
| protected

Destroy notifications.

F32 mDistanceToTarget
| protected

S32 mDstBlendFactor
| protected

bool mEditorTickAllowed
| protected

bool mFadeActive
| protected

bool mGatherContacts
| protected

bool mGrowActive
| protected

bool mLastAwakeState
| protected

Vector2 mLastCheckedPosition
| protected

F32 mLifetime
| protected

Lifetime.

bool mLifetimeActive
| protected

Vector2 mLocalSizeOOBB[4]
| protected

SceneWindow* mpAttachedCamera
| protected

Camera mounting.

GuiControl* mpAttachedGui
| protected

SceneWindow* mpAttachedGuiSceneWindow
| protected

b2Body* mpBody
| protected

Body.

Scene::typeContactVector* mpCurrentContacts
| protected

bool mPickingAllowed
| protected

b2AABB mPreTickAABB
| protected

F32 mPreTickAngle
| protected

Vector2 mPreTickPosition
| protected

Position / Angle.

SimObjectPtr<Scene> mpScene
| protected

Scene.

SimObjectPtr<Scene> mpTargetScene
| protected

Target Scene. NOTE: Unfortunately this is required as the scene can be set via a field which occurs before the object is registered with the simulation therefore any simulation related functionality cannot be used such as TorqueScript callbacks.

F32 mRenderAngle
| protected

StringTableEntry mRenderGroup
| protected

Vector2 mRenderOOBB[4]
| protected

Vector2 mRenderPosition
| protected

U32 mRotateToEventId
| protected

bool mSafeDeleteReady
| protected

U32 mSceneGroup
| protected

Scene groups.

U32 mSceneGroupMask
| protected

U32 mSceneLayer
| protected

Scene layers.

F32 mSceneLayerDepth
| protected

U32 mSceneLayerMask
| protected

U32 mSerialId
| protected

U32 mSerialiseKey
| protected

Vector2 mSize
| protected

Area.

bool mSleepingCallback
| protected

bool mSnapToTargetPosition
| protected

Vector2 mSortPoint
| protected

Render sorting.

bool mSpatialDirty
| protected

S32 mSrcBlendFactor
| protected

bool mStopAtTargetPosition
| protected

ColorF mTargetColor
| protected

Vector2 mTargetPosition
| protected

bool mTargetPositionActive
| protected

bool mTargetPositionFound
| protected

F32 mTargetPositionMargin
| protected

Vector2 mTargetSize
| protected

bool mUpdateCallback
| protected

Script callbacks.

bool mUseInputEvents
| protected

Input events.

bool mVisible
| protected

Render visibility.

S32 mWorldProxyId
| protected

U32 mWorldQueryKey
| protected

The documentation for this class was generated from the following files:

- 2d/sceneobject/SceneObject.h
- 2d/sceneobject/SceneObject.cc